#ifndef _ttail_search_std_h__
#define _ttail_search_std_h__

#include <errno.h>
#include <string.h>
#include <stdlib.h>

typedef struct _ttail_search_stdin_s ttail_search_stdin_t;
/*<! Private search session for stdin */
struct _ttail_search_stdin_s
{
	char *buff;
	size_t buff_sz;
};

#include "config.h"
#include "ttail.h"
#include "ttail_search.h"

/**@brief Convenient wrapper for getline
 *@param ttail_t* TTAIL
 *@param size_t ID file id
 *@return @ref getline()
 */
#define ttail_std_getline(TTAIL) (getline(\
	&(TTAIL->session->std.buff), &(TTAIL->session->std.buff_sz), stdin))
/*<!Accessor to getline wrapper buffer */
#define ttail_std_getline_buff(TTAIL) (TTAIL->session->std.buff)

/**@brief init private session members
 *@patam ttail_t* t
 *@return -1 on error else 0
 *@todo checks
 */
int _ttail_search_closest_std_init(ttail_t* t);

/**@brief @ref ttail_search_closest() implementation for stdin
 *@note when returns ttail->session->std.buff contains the first
 *line to print
 *@param ttail_t*
 *@param struct tm* tmin
 *@return 0 if ok -1 if fatal error 1 if not found
 *@todo checks
 */
int _ttail_search_closest_stdin(ttail_t*);
/**@brief Output result loglines to stdout
 *@param ttail_t*
 *@param int fd
 *@todo checks
 */
void _ttail_search_print_stdin(ttail_t*, int);

/**@brief free private session members
 *@patam ttail_t* t
 */
void _ttail_search_stdin_free(ttail_t* t);

#endif

