#include "ttail_search_std.h"

int _ttail_search_closest_std_init(ttail_t* t)
{
	t->session = (ttail_search_t*)malloc(sizeof(ttail_search_stdin_t));
	if(!t->session)
	{
		perror("Unable to allocate memory for search session");
		return -1;
	}
	t->session->std.buff = NULL;
	t->session->std.buff_sz = 0;
	return 0;
}

int _ttail_search_closest_stdin(ttail_t* t)
{
	struct tm tm;
	ssize_t rd_sz;
	int ret, tmp;
	if(_ttail_search_closest_std_init(t) < 0)
	{
		return -1;
	}
	if(!(t->flag & TTAIL_FLAG_DATE_MIN))
	{
		return 0;
	}
	while((rd_sz = ttail_std_getline(t)) > 0)
	{
		ttail_tm_init(&tm);
		ret = ttail_logline2date(t, ttail_std_getline_buff(t), &tm);
		if(ret < 0)
		{
			return -1;
		}
		else if(ret > 0)
		{
			continue;
		}
		ret = ttail_tm_cmp(&tm, &(t->date_min));
		if(ret >= 0)
		{
			//buffer contains the first line to print
			return 0;
		}
	}
	if(rd_sz < 0)
	{
		tmp = errno;
		ret = feof(stdin);
		if(ret <= 0)
		{
			errno = tmp;
			perror("Error while reading loglines from stdin");
			return -1;
		}
	}
	return 0;
}

void _ttail_search_print_stdin(ttail_t* t, int fd)
{
	struct tm tm;
	ssize_t rd_sz;
	int ret, tmp;
	
	rd_sz = strlen(ttail_std_getline_buff(t));
	if(!(t->flag & TTAIL_FLAG_DATE_MAX))
	{
		do
		{
			ret = write(1, ttail_std_getline_buff(t),
				sizeof(char)*rd_sz);
			if(ret < 0)
			{
				perror("Unable to write to stdout");
				return;
			}
		}
		while((rd_sz = ttail_std_getline(t)) > 0);
	}
	else
	{
		do
		{
			ttail_tm_init(&tm);
			ret = ttail_logline2date(t, ttail_std_getline_buff(t),
				&tm);
			//dropping errors
			if(ret == 0)
			{
				ret = ttail_tm_cmp(&tm, &(t->date_max));
				if(ret > 0)
				{
					return;
				}
			}
			ret = write(1, ttail_std_getline_buff(t),
				sizeof(char)*rd_sz);
			if(ret < 0)
			{
				perror("Unable to write to stdout");
				return;
			}
		}
		while((rd_sz = ttail_std_getline(t)) > 0);
	}
	if(rd_sz < 0)
	{
		tmp = errno;
		ret = feof(stdin);
		if(ret <= 0)
		{
			errno = tmp;
			perror("Error while reading loglines from stdin");
		}
	}
	return;
}

void _ttail_search_stdin_free(ttail_t* t)
{
	if(t->session->std.buff)
	{
		free(t->session->std.buff);
	}
}

